Index: src/org/jboss/tools/deltacloud/core/DeltaCloudManager.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/DeltaCloudManager.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/DeltaCloudManager.java	(working copy)
@@ -103,16 +103,20 @@
 			String username = URLEncoder.encode(
 					attrs.getNamedItem(DeltaCloudXMLBuilder.ATTR_USERNAME).getNodeValue(),
 					DeltaCloudXMLBuilder.ENCODING); // $NON-NLS-1$
-			Driver driver = Driver.checkedValueOf(attrs.getNamedItem(DeltaCloudXMLBuilder.ATTR_TYPE).getNodeValue()); // $NON-NLS-1$
+			DeltaCloudDriver driver = DeltaCloudDriver.checkedValueOf(attrs.getNamedItem(DeltaCloudXMLBuilder.ATTR_TYPE).getNodeValue()); // $NON-NLS-1$
 			String imageFilterRules = getImageFilterRules(attrs.getNamedItem("imagefilter")); // $NON-NLS-1$
-			String instanceFilterRules = getInstanceFilterRules(attrs.getNamedItem("instancefilter")); // $NON-NLS-1$
+			String instanceFilterRules = getNodeValue(attrs.getNamedItem("instancefilter")); // $NON-NLS-1$
 			String lastKeyName = getNodeValue(attrs.getNamedItem(DeltaCloudXMLBuilder.ATTR_LASTKEYNAME)); // $NON-NLS-1$
 			String lastImageId = getNodeValue(attrs.getNamedItem(DeltaCloudXMLBuilder.ATTR_LASTIMAGE)); // $NON-NLS-1$
+			String lastRealmName = getNodeValue(attrs.getNamedItem(DeltaCloudXMLBuilder.ATTR_LASTREALM)); // $NON-NLS-1$
+			String lastProfileId = getNodeValue(attrs.getNamedItem(DeltaCloudXMLBuilder.ATTR_LASTPROFILE)); // $NON-NLS-1$
 			Collection<IInstanceAliasMapping> aliasMappings = getInstanceMappings(n);
 			cloud = new DeltaCloud(name, url, username, driver, imageFilterRules, instanceFilterRules, aliasMappings);
 			clouds.add(cloud);
 			cloud.setLastImageId(lastImageId);
 			cloud.setLastKeyname(lastKeyName);
+			cloud.setLastRealmName(lastRealmName);
+			cloud.setLastProfileId(lastProfileId);
 			return cloud;
 		} catch (DeltaCloudException e) {
 			throw e;
@@ -162,16 +166,8 @@
 		return null;
 	}
 
-	private String getInstanceFilterRules(Node instanceFilterNode) {
-		String instanceFilterRules = IInstanceFilter.ALL_STRING;
-		if (instanceFilterNode != null) {
-			instanceFilterRules = instanceFilterNode.getNodeValue();
-		}
-		return instanceFilterRules;
-	}
-
 	private String getImageFilterRules(Node imageFilterNode) {
-		String imageFilterRules = IImageFilter.ALL_STRING;
+		String imageFilterRules = null;
 		if (imageFilterNode != null) {
 			imageFilterRules = imageFilterNode.getNodeValue();
 		}
@@ -216,6 +212,8 @@
 				DeltaCloudXMLBuilder.ATTR_INSTANCEFILTER, d.getInstanceFilter().toString(), printWriter);
 		DeltaCloudXMLBuilder.attribute(DeltaCloudXMLBuilder.ATTR_LASTKEYNAME, d.getLastKeyname(), printWriter);
 		DeltaCloudXMLBuilder.attribute(DeltaCloudXMLBuilder.ATTR_LASTIMAGE, d.getLastImageId(), printWriter);
+		DeltaCloudXMLBuilder.attribute(DeltaCloudXMLBuilder.ATTR_LASTREALM, d.getLastRealmName(), printWriter);
+		DeltaCloudXMLBuilder.attribute(DeltaCloudXMLBuilder.ATTR_LASTPROFILE, d.getLastProfileId(), printWriter);
 		DeltaCloudXMLBuilder.closeTag(printWriter);
 		printInstances(d, printWriter);
 		DeltaCloudXMLBuilder.endTag(DeltaCloudXMLBuilder.TAG_CLOUD, printWriter);
Index: src/org/jboss/tools/deltacloud/core/client/Realm.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/Realm.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/client/Realm.java	(working copy)
@@ -14,7 +14,7 @@
  * @author Martyn Taylor
  * @author André Dietisheim
  */
-public class Realm extends AbstractDeltaCloudObject {
+public class Realm extends IdAware {
 	private static final long serialVersionUID = 1L;
 
 	public static final int LIMIT_DEFAULT = -1;
Index: src/org/jboss/tools/deltacloud/core/ImageFilter.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/ImageFilter.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/ImageFilter.java	(working copy)
@@ -11,7 +11,6 @@
 package org.jboss.tools.deltacloud.core;
 
 import java.util.Iterator;
-import java.util.regex.PatternSyntaxException;
 
 /**
  * A filter that may be applied on DeltaCloudImages
@@ -24,40 +23,64 @@
 public class ImageFilter extends AbstractCloudElementFilter<DeltaCloudImage> implements IImageFilter {
 
 	private IFieldMatcher archRule;
+	private IFieldMatcher descRule;
 
 	public ImageFilter(DeltaCloud cloud) {
+		super(new AllMatcher(), new AllMatcher(), cloud);
+		setRules(new AllMatcher(), new AllMatcher());
+	}
+
+	public ImageFilter(String rules, DeltaCloud cloud) {
 		super(cloud);
+		setRules(rules);
 	}
 
-	private IFieldMatcher descRule;
-	
+	public ImageFilter(String nameRule, String idRule, String archRule, String descRule, DeltaCloud cloud) {
+		super(nameRule, idRule, cloud);
+		setRules(archRule, descRule);
+	}
+
 	@Override
-	public boolean matches(DeltaCloudImage image) {
-		return super.matches(image) &&
-		archRule.matches(image.getArchitecture()) &&
-		descRule.matches(image.getDescription());
+	protected Iterator<String> setRules(String rules) {
+		Iterator<String> rulesIterator = super.setRules(rules);
+		setRules(createRule(rulesIterator), createRule(rulesIterator));
+		return rulesIterator;
+	}
+
+	private void setRules(String archRule, String descRule) {
+		setRules(createRule(archRule), createRule(descRule));
+	}
+
+	private void setRules(IFieldMatcher archMatcher, IFieldMatcher descMatcher) {
+		this.archRule = archMatcher;
+		this.descRule = descMatcher;
 	}
 
 	@Override
-	public void setRules(String ruleString) throws PatternSyntaxException {
-		// TODO: replace filter passing (;-delimited string) by list
-		Iterator<String> rulesIterator = super.setRules(ruleString, getRulesIterator(ruleString));		
-		this.archRule = createRule(rulesIterator);
-		this.descRule = createRule(rulesIterator);
+	public boolean matches(DeltaCloudImage image) {
+		return super.matches(image) &&
+				archRule.matches(image.getArchitecture()) &&
+				descRule.matches(image.getDescription());
 	}
-	
+
 	@Override
 	public String toString() {
-		return super.toString()  //$NON-NLS-1$
-		+ archRule + ";"  //$NON-NLS-1$
-		+ descRule; //$NON-NLS-1$
+		return super.toString() //$NON-NLS-1$
+				+ archRule + EXPRESSION_DELIMITER //$NON-NLS-1$
+				+ descRule; //$NON-NLS-1$
 	}
-	
+
 	public IFieldMatcher getArchRule() {
 		return archRule;
 	}
-	
+
 	public IFieldMatcher getDescRule() {
 		return descRule;
 	}
+
+	public boolean isFiltering() {
+		return super.isFiltering()
+				|| !archRule.isMatchesAll()
+				|| !descRule.isMatchesAll();
+	}
 }
Index: src/org/jboss/tools/deltacloud/core/job/InstanceStateJob.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/job/InstanceStateJob.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/job/InstanceStateJob.java	(working copy)
@@ -32,6 +32,8 @@
 	protected IStatus doRun(IProgressMonitor monitor) throws Exception {
 		String id = getInstance().getId();
 		getCloud().waitForState(id, expectedState, monitor);
+		if( monitor.isCanceled())
+			return Status.CANCEL_STATUS;
 		return Status.OK_STATUS;
 	}
 
Index: src/org/jboss/tools/deltacloud/core/Activator.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/Activator.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/Activator.java	(working copy)
@@ -11,11 +11,14 @@
 package org.jboss.tools.deltacloud.core;
 
 import java.lang.reflect.InvocationTargetException;
+import java.util.ArrayList;
+import java.util.List;
 
 import org.eclipse.core.runtime.CoreException;
 import org.eclipse.core.runtime.IStatus;
 import org.eclipse.core.runtime.Plugin;
 import org.eclipse.core.runtime.Status;
+import org.jboss.tools.common.log.StatusFactory;
 import org.osgi.framework.BundleContext;
 
 /**
@@ -81,5 +84,14 @@
 			status = new Status(IStatus.ERROR, PLUGIN_ID, IStatus.OK, e.getMessage(), e);
 		log(status);
 	}
-
+	public static IStatus createMultiStatus(DeltaCloudMultiException throwable) {
+		List<IStatus> states = new ArrayList<IStatus>(throwable.getThrowables().size());
+		for (Throwable childThrowable : throwable.getThrowables()) {
+			IStatus status = StatusFactory.getInstance(IStatus.ERROR, Activator.PLUGIN_ID, childThrowable.getMessage(),
+					childThrowable);
+			states.add(status);
+		}
+		return StatusFactory.getInstance(IStatus.ERROR, Activator.PLUGIN_ID, throwable.getMessage(), throwable,
+				states.toArray(new IStatus[states.size()]));
+	}
 }
Index: src/org/jboss/tools/deltacloud/core/client/IdAware.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/IdAware.java	(revision 0)
+++ src/org/jboss/tools/deltacloud/core/client/IdAware.java	(revision 0)
@@ -0,0 +1,37 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat Inc..
+ * All rights reserved. This program and the accompanying materials
+ * are made available under the terms of the Eclipse Public License v1.0
+ * which accompanies this distribution, and is available at
+ * http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat Incorporated - initial API and implementation
+ *******************************************************************************/
+package org.jboss.tools.deltacloud.core.client;
+
+import javax.xml.bind.annotation.XmlAttribute;
+
+/**
+ * @author Martyn Taylor
+ * @author André Dietisheim
+ */
+public abstract class IdAware {
+
+	protected String id;
+
+	public void setId(String id) {
+		this.id = id;
+	}
+
+	@XmlAttribute
+	public String getId() {
+		return id;
+	}
+
+	@Override
+	public String toString() {
+		return "IdAware [id=" + id + "]";
+	}
+
+}
Index: src/org/jboss/tools/deltacloud/core/DeltaCloudInstance.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/DeltaCloudInstance.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/DeltaCloudInstance.java	(working copy)
@@ -13,12 +13,10 @@
 import java.util.ArrayList;
 import java.util.List;
 
+import org.jboss.tools.deltacloud.core.client.Action;
+import org.jboss.tools.deltacloud.core.client.DeltaCloudClient;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudClientException;
-import org.jboss.tools.deltacloud.core.client.IInstanceAction;
 import org.jboss.tools.deltacloud.core.client.Instance;
-import org.jboss.tools.deltacloud.core.client.Instance.InstanceState;
-import org.jboss.tools.deltacloud.core.client.InstanceAction;
-import org.jboss.tools.deltacloud.core.client.InternalDeltaCloudClient;
 
 /**
  * An instance that may be reached on a DeltaCloud instance. Wraps Instance from
@@ -34,14 +32,14 @@
 
 	public enum State {
 
-		PENDING(Instance.InstanceState.PENDING.name()),
-		RUNNING(Instance.InstanceState.RUNNING.name()),
-		STOPPED(Instance.InstanceState.STOPPED.name()),
-		TERMINATED(Instance.InstanceState.TERMINATED.name()),
-		BOGUS(Instance.InstanceState.BOGUS.name());
+		PENDING(Instance.State.PENDING.name()),
+		RUNNING(Instance.State.RUNNING.name()),
+		STOPPED(Instance.State.STOPPED.name()),
+		TERMINATED(Instance.State.TERMINATED.name()),
+		BOGUS(Instance.State.BOGUS.name());
 
 		private String name;
-
+		
 		private State(String name) {
 			this.name = name;
 		}
@@ -55,24 +53,6 @@
 		}
 	}
 
-	public enum Action {
-
-		START(IInstanceAction.START),
-		STOP(IInstanceAction.STOP),
-		REBOOT(IInstanceAction.REBOOT),
-		DESTROY(InstanceAction.DESTROY);
-
-		private String name;
-
-		private Action(String name) {
-			this.name = name;
-		}
-
-		public String getName() {
-			return name;
-		}
-	}
-
 	private Instance instance;
 	private String alias;
 
@@ -115,10 +95,10 @@
 		return instance.getKeyId();
 	}
 	
-	public List<Action> getActions() {
-		List<Action> actions = new ArrayList<Action>();
-		for (InstanceAction action : instance.getActions()) {
-			actions.add(Action.valueOf(action.getName()));
+	public List<DeltaCloudResourceAction> getActions() {
+		List<DeltaCloudResourceAction> actions = new ArrayList<DeltaCloudResourceAction>();
+		for (Action<Instance> action : instance.getActions()) {
+			actions.add(DeltaCloudResourceAction.valueOf(action.getName()));
 		}
 		return actions;
 	}
@@ -140,7 +120,7 @@
 	}
 
 	public boolean isStopped() {
-		return instance.getState() == InstanceState.STOPPED;
+		return instance.isStopped();
 	}
 
 	public boolean canStart() {
@@ -176,13 +156,13 @@
 		return hostName;
 	}
 
-	protected boolean performInstanceAction(Action action, InternalDeltaCloudClient client)
+	protected boolean performAction(DeltaCloudResourceAction action, DeltaCloudClient client)
 			throws DeltaCloudClientException {
-		InstanceAction instanceAction = instance.getAction(action.getName());
+		Action<Instance> instanceAction = instance.getAction(action.getName());
 		if (instanceAction == null) {
 			return false;
 		}
-		return client.performInstanceAction(instanceAction);
+		return client.performAction(instanceAction);
 	}
 
 	@Override
@@ -206,11 +186,15 @@
 
 	private StringBuilder appendActions(StringBuilder builder) {
 		builder.append(" actions: [");
-		for (Action action : getActions()) {
+		for (DeltaCloudResourceAction action : getActions()) {
 			builder.append("action: ")
 					.append(action.getName());
 		}
 		builder.append("] ");
 		return builder;
 	}
+
+	public boolean isInState(State state) {
+		return getState() == state;
+	}
 }
Index: src/org/jboss/tools/deltacloud/core/client/unmarshal/AbstractActionAwareUnmarshaller.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/unmarshal/AbstractActionAwareUnmarshaller.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/client/unmarshal/AbstractActionAwareUnmarshaller.java	(working copy)
@@ -14,7 +14,7 @@
 import java.util.ArrayList;
 import java.util.List;
 
-import org.jboss.tools.deltacloud.core.client.AbstractDeltaCloudResourceAction;
+import org.jboss.tools.deltacloud.core.client.Action;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudClientException;
 import org.w3c.dom.Element;
 import org.w3c.dom.Node;
@@ -25,7 +25,7 @@
  *
  * @param <DELTACLOUDOBJECT>
  */
-public abstract class AbstractActionAwareUnmarshaller<DELTACLOUDOBJECT, ACTION extends AbstractDeltaCloudResourceAction<DELTACLOUDOBJECT>> extends AbstractDOMUnmarshaller<DELTACLOUDOBJECT>{
+public abstract class AbstractActionAwareUnmarshaller<DELTACLOUDOBJECT> extends AbstractDOMUnmarshaller<DELTACLOUDOBJECT>{
 
 	private String actionElementName;
 	public AbstractActionAwareUnmarshaller(String tagName, Class<DELTACLOUDOBJECT> type, String actionElementName) {
@@ -33,15 +33,15 @@
 		this.actionElementName = actionElementName;
 	}
 
-	protected List<ACTION> getActions(Element element, DELTACLOUDOBJECT owner) throws DeltaCloudClientException {
+	protected List<Action<DELTACLOUDOBJECT>> getActions(Element element, DELTACLOUDOBJECT owner) throws DeltaCloudClientException {
 		if (element == null) {
 			return null;
 		}
-		List<ACTION> actions = new ArrayList<ACTION>();
+		List<Action<DELTACLOUDOBJECT>> actions = new ArrayList<Action<DELTACLOUDOBJECT>>();
 		NodeList nodeList = element.getElementsByTagName(actionElementName);
 		for (int i = 0; i < nodeList.getLength(); i++) {
 			Node linkNode = nodeList.item(i);
-			ACTION action = createAction(linkNode);
+			Action<DELTACLOUDOBJECT> action = createAction(linkNode);
 			if (action != null) {
 				action.setOwner(owner);
 				actions.add(action);
@@ -50,12 +50,12 @@
 		return actions;
 	}
 
-	protected ACTION createAction(Node node) throws DeltaCloudClientException {
+	protected Action<DELTACLOUDOBJECT> createAction(Node node) throws DeltaCloudClientException {
 		if (!(node instanceof Element)) {
 			return null;
 		}
 		return unmarshallAction((Element) node);
 	}
 	
-	protected abstract ACTION unmarshallAction(Element element) throws DeltaCloudClientException;
+	protected abstract Action<DELTACLOUDOBJECT> unmarshallAction(Element element) throws DeltaCloudClientException;
 }
Index: src/org/jboss/tools/deltacloud/core/client/Action.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/Action.java	(revision 0)
+++ src/org/jboss/tools/deltacloud/core/client/Action.java	(revision 0)
@@ -0,0 +1,85 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+package org.jboss.tools.deltacloud.core.client;
+
+/**
+ * An action that may be performed on a resource
+ * 
+ * @author André Dietisheim
+ */
+public class Action<OWNER> {
+
+	public static final String START_NAME = "start";
+	public static final String STOP_NAME = "stop";
+	public static final String REBOOT_NAME = "reboot";
+	public static final String DESTROY_NAME = "destroy";
+
+	private String name;
+	private String url;
+	private HttpMethod method;
+	private OWNER owner;
+
+	public HttpMethod getMethod() {
+		return method;
+	}
+
+	public void setMethodString(String method) {
+		this.method = HttpMethod.valueOf(method.toUpperCase());
+	}
+
+	public void setMethod(HttpMethod method) {
+		this.method = method;
+	}
+
+	public void setMethod(String method) {
+		this.method = HttpMethod.valueOf(method.toUpperCase());
+	}
+
+	public void setName(String name) {
+		this.name = name;
+	}
+
+	public String getName() {
+		return name;
+	}
+
+	public void setUrl(String url) {
+		this.url = url;
+	}
+
+	public String getUrl() {
+		return url;
+	}
+
+	public void setOwner(OWNER owner) {
+		this.owner = owner;
+	}
+
+	public OWNER getOwner() {
+		return owner;
+	}
+
+	public boolean isStart() {
+		return START_NAME.equals(getName());
+	}
+
+	public boolean isStop() {
+		return STOP_NAME.equals(getName());
+	}
+
+	public boolean isReboot() {
+		return REBOOT_NAME.equals(getName());
+	}
+
+	public boolean isDestroy() {
+		return DESTROY_NAME.equals(getName());
+	}
+}
Index: src/org/jboss/tools/deltacloud/core/DeltaCloudResourceAction.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/DeltaCloudResourceAction.java	(revision 0)
+++ src/org/jboss/tools/deltacloud/core/DeltaCloudResourceAction.java	(revision 0)
@@ -0,0 +1,37 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+package org.jboss.tools.deltacloud.core;
+
+import org.jboss.tools.deltacloud.core.client.Action;
+
+
+/**
+ * @author Jeff Johnston
+ * @author André Dietisheim
+ */
+public enum DeltaCloudResourceAction {
+
+	START(Action.START_NAME),
+	STOP(Action.STOP_NAME),
+	REBOOT(Action.REBOOT_NAME),
+	DESTROY(Action.DESTROY_NAME);
+
+	private String name;
+
+	private DeltaCloudResourceAction(String name) {
+		this.name = name;
+	}
+
+	public String getName() {
+		return name;
+	}
+
+}
Index: src/org/jboss/tools/deltacloud/core/client/unmarshal/APIUnmarshaller.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/unmarshal/APIUnmarshaller.java	(revision 0)
+++ src/org/jboss/tools/deltacloud/core/client/unmarshal/APIUnmarshaller.java	(revision 0)
@@ -0,0 +1,31 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+package org.jboss.tools.deltacloud.core.client.unmarshal;
+
+import org.jboss.tools.deltacloud.core.client.API;
+import org.w3c.dom.Element;
+
+/**
+ * @author André Dietisheim
+ */
+public class APIUnmarshaller extends AbstractDOMUnmarshaller<API> {
+
+	public APIUnmarshaller() {
+		super("api", API.class);
+	}
+
+	protected API doUnmarshall(Element element, API server) throws Exception {
+		if (element != null) {
+			server.setDriver(getAttributeText("driver", element));
+		}
+		return server;
+	}
+}
Index: src/org/jboss/tools/deltacloud/core/client/Image.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/Image.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/client/Image.java	(working copy)
@@ -14,7 +14,7 @@
 /**
  * @author Martyn Taylor
  */
-public class Image extends AbstractDeltaCloudObject
+public class Image extends IdAware
 {	
 	private static final long serialVersionUID = 1L;
 
Index: src/org/jboss/tools/deltacloud/core/IDeltaCloudManagerListener.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/IDeltaCloudManagerListener.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/IDeltaCloudManagerListener.java	(working copy)
@@ -12,8 +12,8 @@
 
 public interface IDeltaCloudManagerListener {
 	
-	public static int ADD_EVENT = 1;
-	public static int REMOVE_EVENT = 2;
+	public final static int ADD_EVENT = 1;
+	public final static int REMOVE_EVENT = 2;
 	
 	void cloudsChanged(int type, DeltaCloud cloud);
 }
Index: src/org/jboss/tools/deltacloud/core/client/DeltaCloudClientImpl.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/DeltaCloudClientImpl.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/client/DeltaCloudClientImpl.java	(working copy)
@@ -10,11 +10,8 @@
  *******************************************************************************/
 package org.jboss.tools.deltacloud.core.client;
 
-import java.io.BufferedReader;
 import java.io.IOException;
 import java.io.InputStream;
-import java.io.InputStreamReader;
-import java.io.StringReader;
 import java.net.MalformedURLException;
 import java.net.URL;
 import java.net.UnknownHostException;
@@ -22,10 +19,6 @@
 import java.util.ArrayList;
 import java.util.List;
 
-import javax.xml.parsers.DocumentBuilder;
-import javax.xml.parsers.DocumentBuilderFactory;
-import javax.xml.parsers.ParserConfigurationException;
-
 import org.apache.http.HttpResponse;
 import org.apache.http.auth.AuthScope;
 import org.apache.http.auth.UsernamePasswordCredentials;
@@ -34,9 +27,9 @@
 import org.apache.http.client.methods.HttpPost;
 import org.apache.http.client.methods.HttpUriRequest;
 import org.apache.http.impl.client.DefaultHttpClient;
+import org.jboss.tools.deltacloud.core.client.API.Driver;
 import org.jboss.tools.deltacloud.core.client.request.CreateInstanceRequest;
 import org.jboss.tools.deltacloud.core.client.request.CreateKeyRequest;
-import org.jboss.tools.deltacloud.core.client.request.DeleteKeyRequest;
 import org.jboss.tools.deltacloud.core.client.request.DeltaCloudRequest;
 import org.jboss.tools.deltacloud.core.client.request.ListHardwareProfileRequest;
 import org.jboss.tools.deltacloud.core.client.request.ListHardwareProfilesRequest;
@@ -48,8 +41,9 @@
 import org.jboss.tools.deltacloud.core.client.request.ListKeysRequest;
 import org.jboss.tools.deltacloud.core.client.request.ListRealmRequest;
 import org.jboss.tools.deltacloud.core.client.request.ListRealmsRequest;
-import org.jboss.tools.deltacloud.core.client.request.PerformInstanceActionRequest;
+import org.jboss.tools.deltacloud.core.client.request.PerformActionRequest;
 import org.jboss.tools.deltacloud.core.client.request.TypeRequest;
+import org.jboss.tools.deltacloud.core.client.unmarshal.APIUnmarshaller;
 import org.jboss.tools.deltacloud.core.client.unmarshal.HardwareProfileUnmarshaller;
 import org.jboss.tools.deltacloud.core.client.unmarshal.HardwareProfilesUnmarshaller;
 import org.jboss.tools.deltacloud.core.client.unmarshal.ImageUnmarshaller;
@@ -60,28 +54,15 @@
 import org.jboss.tools.deltacloud.core.client.unmarshal.KeysUnmarshaller;
 import org.jboss.tools.deltacloud.core.client.unmarshal.RealmUnmarshaller;
 import org.jboss.tools.deltacloud.core.client.unmarshal.RealmsUnmarshaller;
-import org.w3c.dom.Document;
-import org.w3c.dom.Node;
-import org.w3c.dom.NodeList;
-import org.xml.sax.InputSource;
-import org.xml.sax.SAXException;
 
 /**
  * @author Andre Dietisheim (based on prior implementation by Martyn Taylor)
  */
-public class DeltaCloudClientImpl implements InternalDeltaCloudClient {
-
-	private static final String DOCUMENT_ELEMENT_DRIVER = "driver";
-	private static final String DOCUMENT_ELEMENT_API = "api";
+public class DeltaCloudClientImpl implements DeltaCloudClient {
 
 	private String baseUrl;
 	private String username;
 	private String password;
-	private DocumentBuilderFactory documentBuilderFactory;
-
-	public static enum DeltaCloudServerType {
-		UNKNOWN, MOCK, EC2
-	}
 
 	public DeltaCloudClientImpl(String url) throws MalformedURLException,
 			DeltaCloudClientException {
@@ -92,7 +73,6 @@
 		this.baseUrl = url;
 		this.username = username;
 		this.password = password;
-		this.documentBuilderFactory = DocumentBuilderFactory.newInstance();
 	}
 
 	protected InputStream request(DeltaCloudRequest deltaCloudRequest)
@@ -120,19 +100,6 @@
 		}
 	}
 
-	protected String requestStringResponse(DeltaCloudRequest deltaCloudRequest)
-			throws DeltaCloudClientException {
-		try {
-			InputStream inputStream = request(deltaCloudRequest);
-			if (inputStream == null) {
-				return null;
-			}
-			return getResponse(inputStream);
-		} catch (IOException e) {
-			throw new DeltaCloudClientException(e);
-		}
-	}
-
 	private void throwOnHttpErrors(URL requestUrl, HttpResponse httpResponse)
 			throws DeltaCloudClientException {
 		int statusCode = httpResponse.getStatusLine().getStatusCode();
@@ -158,15 +125,6 @@
 		}
 	}
 
-	private String getResponse(InputStream inputStream) throws IOException,
-			DeltaCloudClientException {
-		if (inputStream == null) {
-			return null;
-		}
-		String xml = readInputStreamToString(inputStream);
-		return xml;
-	}
-
 	/**
 	 * Returns a request instance for the given request type and url.
 	 * 
@@ -216,48 +174,14 @@
 		return httpClient;
 	}
 
-	private static String readInputStreamToString(InputStream is)
-			throws DeltaCloudClientException {
+	public Driver getServerType() {
 		try {
-			try {
-				if (is != null) {
-					StringBuilder sb = new StringBuilder();
-					String line = null;
-
-					BufferedReader reader = new BufferedReader(new InputStreamReader(is, "UTF-8"));
-					while ((line = reader.readLine()) != null) {
-						sb.append(line).append("\n");
-					}
-					return sb.toString();
-				}
-			} finally {
-				is.close();
-			}
-		} catch (Exception e) {
-			throw new DeltaCloudClientException(
-					"Error converting Response to String", e);
-		}
-		return "";
-	}
-
-	public DeltaCloudServerType getServerType() {
-		DeltaCloudServerType serverType = DeltaCloudServerType.UNKNOWN;
-		try {
-			String apiResponse = requestStringResponse(new TypeRequest(baseUrl));
-			Document document = getDocument(apiResponse);
-			NodeList elements = document.getElementsByTagName(DOCUMENT_ELEMENT_API);
-			if (elements.getLength() > 0) {
-				Node n = elements.item(0);
-				Node driver = n.getAttributes().getNamedItem(DOCUMENT_ELEMENT_DRIVER);
-				if (driver != null) {
-					String driverValue = driver.getNodeValue();
-					serverType = DeltaCloudServerType.valueOf(driverValue.toUpperCase());
-				}
-			}
-		} catch (Exception e) {
-			serverType = DeltaCloudServerType.UNKNOWN;
+			InputStream response = request(new TypeRequest(baseUrl));
+			API api = new APIUnmarshaller().unmarshall(response, new API());
+			return api.getDriver();
+		} catch (DeltaCloudClientException e) {
+			return Driver.UNKNOWN;
 		}
-		return serverType;
 	}
 
 	@Override
@@ -395,10 +319,6 @@
 		}
 	}
 
-	public void deleteKey(String keyname) throws DeltaCloudClientException {
-		request(new DeleteKeyRequest(baseUrl, keyname));
-	}
-
 	public List<Key> listKeys() throws DeltaCloudClientException {
 		InputStream inputStream = request(new ListKeysRequest(baseUrl));
 		List<Key> keys = new ArrayList<Key>();
@@ -412,21 +332,10 @@
 		return key;
 	}
 
-	private Document getDocument(String response) throws ParserConfigurationException, SAXException, IOException {
-		InputSource is = new InputSource(new StringReader(response));
-		DocumentBuilder documentBuilder = documentBuilderFactory.newDocumentBuilder();
-		Document document = documentBuilder.parse(is);
-		return document;
-	}
-
-	public boolean performInstanceAction(InstanceAction action) throws DeltaCloudClientException {
+	public boolean performAction(Action<?> action) throws DeltaCloudClientException {
 		if (action != null) {
 			try {
-				InputStream inputStream = request(
-						new PerformInstanceActionRequest(action.getUrl(), action.getMethod()));
-				if (!InstanceAction.DESTROY.equals(action.getName())) {
-					new InstanceUnmarshaller().unmarshall(inputStream, action.getOwner());
-				}
+				request(new PerformActionRequest(action.getUrl(), action.getMethod()));
 			} catch (DeltaCloudClientException e) {
 				throw e;
 			} catch (Exception e) {
